Subject: bug#67357: [PATCH] Fix c-ts-mode block indent when first-siblings are comments

From: Eli Zaretskii <[email-masked]>
Date: Thu, 23 Nov 2023 09:35:13 +0200

> From: Noah Peart <[email-masked]>
> Date: Tue, 21 Nov 2023 17:50:52 -0800
> 
> I wasn't sure if these should be two separate bugs, so I separated them just 
> in case.
> 
> * lisp/progmodes/c-ts-mode.el(c-ts-mode--indent-styles): Fix indentation
> in block statements for cases when the first-sibling(s) are comments or
> nested keywords (else_clause/do while).
> 
> Bug: The first statement in a compound statement that is preceded by a
> comment (or multiple comments) isn't indented.
> 
> For example, the `if` statement isnt indented in the following code in
> `c-ts-mode` using `linux` style.
> 
>     int main() {
>       while (true) { /* foo */
>      if (true) { // this line isnt indented
>           puts ("Hello"); // and this isnt either
>         }
>       }
>     }
> 
> * lisp/progmodes/c-ts-mode.el(c-ts-mode--indent-styles): Fix indentation
> for else_clause and do-while in bracket-less block statements using
> `linux` style.
> 
> Bug: There is no matching indent rule for bracket-less else_clause
> statements and the "while" in a bracket-less do-while statement is
> indented to the same level as the do body.
> 
> To reproduce, using `linux` style in `c-ts-mode`.
> 
>     int main() {
>       if (true) 
>         puts("Hello");
>       else 
>       puts("No matched rule!");
>       do 
>         puts("Hello");
>         while (indented_as_part_of_block);
>     }

I'm not sure I can reproduce these, it seems to me that the
indentation is correct in these case when I try the examples.  So
please show a detailed recipe, starting from "emacs -Q", for each of
the two problems, so that we could be sure that we are seeing the same
problems.

Also, please tell if the same problems exist on the emacs-29 branch.

Adding Yuan to the discussion.